<?php
/**
 * (c) 2020 Passlogy Co., Ltd. All Rights Reserved.
 * 
 * https://www.passlogy.com/pdf/PassLogicEndUserLicenseAgreem_ent_ja.pdf
 * https://www.passlogy.com/pdf/PassLogicEndUserLicenseAgreem_ent_en.pdf
 */
?>
<?php
 require_once LIB_DIR . '/database/databaseManager.inc.php'; require_once LIB_DIR . '/database/passlogic_config.php'; define("LOG_DEFINE", APPS_DIR . "/passlogic-log.xml"); define("LOG_CACHE", "/opt/passlogic/tmp/passlogic-log.cache"); class PasslogicLog { var $class_name = "PasslogicLog"; var $pdo; function __construct($locale = "en") { $this->locale = $locale; $pdo = getPDO(); $this->passlogic_config = new passlogic_config($pdo); $log_conf = $this->passlogic_config->get_config('log_config', 'default', ''); $this->loglevel_conf = $log_conf['loglevel']; $this->log_handler = $log_conf['handler']; $this->facility = $log_conf['facility']; } function log($code, $uid, $domain, $tenant = '', $option = NULL, $commit = true) { $tenant_controller = new tenant_controller('user'); if (MULTI_TENANT AND $tenant != "" AND !$tenant_controller->tenantExist($tenant)) { $uid .= "@" . $tenant; $tenant = ""; } $log_arr = $this->_get_log_def($code); $level = $log_arr['level']; $message = $log_arr['message']; if (isset($option['additional_message'])) { $message = $message . ' ' . $option['additional_message']; } if ($this->_get_level_num($this->loglevel_conf) < $this->_get_level_num($level)) { return false; } if (isset($option['host_ip'])) { $host_ip = $option['host_ip']; } else { $host_ip = $_SERVER['SERVER_ADDR']; } if (isset($option['client_ip'])) { $client_ip = $option['client_ip']; } else { $client_ip = filter_input(INPUT_SERVER, 'HTTP_X_IP_ADDR') ? rtrim(filter_input(INPUT_SERVER, 'HTTP_X_IP_ADDR')) : filter_input(INPUT_SERVER, 'REMOTE_ADDR'); } if (isset($option['client_ua'])) { $client_ua = $option['client_ua']; } else { $client_ua = filter_input(INPUT_SERVER, 'HTTP_USER_AGENT'); } if (isset($option['client_cookie'])) { $client_cookie = $option['client_cookie']; } $log_time = microtime(true); $admin_id = $_SESSION['_admin']['uid']; $log_str = date('Y/m/d H:i:s') . "\t"; $log_str .= $log_time . "\t"; $log_str .= "uid=" . $uid . "\t"; $log_str .= "domain=" . $domain . "\t"; $log_str .= "level=" . $level . "\t"; $log_str .= "code=" . $code . "\t"; $log_str .= "message=" . $message . "\t"; $log_str .= "host_ip=" . $host_ip . "\t"; $log_str .= "client_ip=" . $client_ip . "\t"; $log_str .= "client_ua=" . $client_ua . "\t"; $log_str .= "client_cookie=" . $client_cookie . "\t"; $log_str .= "admin_id=" . $admin_id; if (!$this->_logging_file($log_str, $tenant)) { return false; } if (file_exists(DATA_DIR . '/conf/flag/redundant') && file_exists(DATA_DIR . '/conf/flag/redundant_status')) { $file_name = file_get_contents(DATA_DIR . '/conf/flag/other_server'); $OTHER_SERVER = file_get_contents(DATA_DIR . '/conf/flag/' . $file_name); $post_data = http_build_query(array("mode" => "log_transfer", "message" => $log_str, "tenant" => $tenant), "", "&"); $http_options = array( "http" => array( "method" => "POST", "content" => $post_data, ) ); $url = "http://" . $OTHER_SERVER . ":7080/passlogic/api/transfer"; file_get_contents($url, false, stream_context_create($http_options)); } if ($this->log_handler == 'syslog') { if (!$this->_logging_syslog($level, $log_str)) { return false; } } return true; } function _logging_file($message, $tenant = '') { if ($tenant) { $log_file_path = '/var/log/passlogic/passlogic-' . $tenant . '.log'; } else { $log_file_path = '/var/log/passlogic/passlogic.log'; } set_error_handler(function($error_level, $error_message) { restore_error_handler(); $isSuppressed = !boolval($error_level & error_reporting()); if($isSuppressed) return; $timestamp = date('Y/m/d H:i:s'); $error_log = "[${timestamp}]${error_message}\n"; file_put_contents('/var/log/passlogic/logerror.log', $error_log, FILE_APPEND | LOCK_EX); }); if (!file_put_contents($log_file_path, $message . "\n", FILE_APPEND | LOCK_EX)) { exit; } restore_error_handler(); return true; } function _logging_syslog($loglevel, $message) { $facilities = array( "local0" => LOG_LOCAL0, "local1" => LOG_LOCAL1, "local2" => LOG_LOCAL2, "local3" => LOG_LOCAL3, "local4" => LOG_LOCAL4, "local5" => LOG_LOCAL5, "local6" => LOG_LOCAL6, "local7" => LOG_LOCAL7 ); if ($this->facility) { $facility = $facilities[strtolower($this->facility)]; } else { $facility = LOG_LOCAL0; } openlog('passlogic', LOG_ODELAY, $facility); $message = "[" . $loglevel . "] " . $message; $ret = syslog($this->_get_level_num($loglevel), $message); if( !$ret ) { die("syslog error"); } closelog(); return true; } function _get_level_num($loglevel) { $levels = array( 'emerg' => LOG_EMERG, 'alert' => LOG_ALERT, 'crit' => LOG_CRIT, 'err' => LOG_ERR, 'warning' => LOG_WARNING, 'notice' => LOG_NOTICE, 'info' => LOG_INFO, 'debug' => LOG_DEBUG ); return $levels[strtolower($loglevel)]; } function _get_log_def($code) { $logxml = $this->_get_log_xml(); $logxml = $logxml[$code]; if (is_array($logxml)) { return $logxml; } else { return array( "code" => $code, "level" => 'emerg', "message" => "log code \"$code\" does not exist.", "message_ja" => "ログコード\"$code\"は存在しません。" ); } } function _get_log_xml() { clearstatcache(); if (file_exists(LOG_CACHE)) { $stat_original = stat(LOG_DEFINE); $stat_cache = stat(LOG_CACHE); if (!$stat_original OR ! $stat_cache) return false; if ($stat_cache[9] > $stat_original[9]) { $fp = fopen(LOG_CACHE, "r"); $cache = fread($fp, filesize(LOG_CACHE)); fclose($fp); $res_arr = unserialize($cache); return $res_arr; } } $xml = simplexml_load_file(LOG_DEFINE); if( !$xml ) { die("xmp parse error"); } $status_arr = json_decode( json_encode( $xml ), TRUE ); foreach ($status_arr['log'] as $val) { $res_arr[$val['code']] = array( "code" => $val['code'], "level" => $val['level'], "message" => $val['message'], "message_ja" => $val['message_ja'] ); } $fp = @fopen(LOG_CACHE, "w"); if ($fp) { fwrite($fp, serialize($res_arr)); fclose($fp); } return $res_arr; } } ?>
