<?php
/**
 * (c) 2020 Passlogy Co., Ltd. All Rights Reserved.
 * 
 * https://www.passlogy.com/pdf/PassLogicEndUserLicenseAgreem_ent_ja.pdf
 * https://www.passlogy.com/pdf/PassLogicEndUserLicenseAgreem_ent_en.pdf
 */
?>
<?php
 require_once(LIB_DIR . '/database/passlogic_tenant.php'); require_once(LIB_DIR . '/database/passlogic_admin.php'); require_once(LIB_DIR . '/database/passlogic_user.php'); require_once(LIB_DIR . '/database/passlogic_token.php'); require_once(LIB_DIR . '/database/passlogic_config.php'); require_once(LIB_DIR . '/database/passlogic_session.php'); require_once(LIB_DIR . "/ldap.inc.php"); require_once(LIB_DIR . "/tenant_flag.php"); class tenant_controller { var $tenant; var $session_name; private $passlogic_tenant; const TARGET_TENANT_SESSION = '_TARGET_TENANT'; function __construct($mode = 'admin') { if ($mode === 'admin') { $this->session_name = "_admin"; } elseif ($mode === 'maintenance') { $this->session_name = "_maintenance"; } elseif ($mode == 'api') { $this->session_name = null; } else if(defined("PL_AUTH_KEY")) { $this->session_name = PL_AUTH_KEY; } else { $this->session_name = null; } $this->passlogic_tenant = new passlogic_tenant(getPDO()); } function get_tenant() { global $sess; if (!MULTI_TENANT) { return ''; } if ($this->session_name) { $auth = $sess->get_var($this->session_name); if (isset($auth['tenant'])) { return $auth['tenant']; } } $tenant_get = filter_input(INPUT_GET, 'tenant'); if (!is_null($tenant_get)) { return $tenant_get; } $tenant_post = filter_input(INPUT_POST, 'tenant'); if (!is_null($tenant_post)) { return $tenant_post; } return ''; } function get_targetTenant() { global $sess; if (!$this->get_tenant()) { if (filter_input(INPUT_POST, 'target_tenant') !== NULL) { $target_tenant = filter_input(INPUT_POST, 'target_tenant'); $sess->register(self::TARGET_TENANT_SESSION, $target_tenant); } elseif (filter_input(INPUT_GET, 'target_tenant') !== NULL) { $target_tenant = filter_input(INPUT_GET, 'target_tenant'); $sess->register(self::TARGET_TENANT_SESSION, $target_tenant); } elseif ($sess->get_var(self::TARGET_TENANT_SESSION) !== NULL) { $target_tenant = $sess->get_var(self::TARGET_TENANT_SESSION); } else { $target_tenant = ''; $sess->register(self::TARGET_TENANT_SESSION, $target_tenant); } } else { $target_tenant = $this->get_tenant(); } return $target_tenant; } function getTenantData($tenant) { return $this->passlogic_tenant->get_tenant_data($tenant); } function getAllTenantData() { return $this->passlogic_tenant->get_tenant_data_list(); } function setTenantData($tenant, $param_set) { return $this->passlogic_tenant->set_tenantdata($tenant, $param_set); } public function getTenantDataForPager($where_set, $where_param, $order_by, $limit, $offset) { return $this->passlogic_tenant->get_tenantdata_for_pager($where_set, $where_param, $order_by, $limit, $offset); } function getTenantList() { $tenant_list = $this->passlogic_tenant->get_tenant_data_list(); $tenant_name_list = array('' => ''); if (isset($tenant_list)) { foreach ($tenant_list as $data) { $tenant_name_list[$data['tenant']] = $data['tenant']; } } return $tenant_name_list; } function isMasterTenant() { if (MULTI_TENANT && $this->get_tenant() === '') { return true; } return false; } function isTenantAdmin() { if (MULTI_TENANT && $this->get_tenant() !== '') { return true; } return false; } public function getAllocatedUserCount($tenant = null) { if ($tenant) { $tenant_config = $this->passlogic_tenant->get_tenant_data($tenant); return $tenant_config['max_user_num']; } else { $tenant_list = $this->passlogic_tenant->get_tenant_data_list(); if ($tenant_list[0]) { foreach ($tenant_list as $data) { $num += $data['max_user_num']; } } return $num; } } public function tenantExist($tenant) { if (is_null($tenant) || $tenant == '') { return false; } $data = $this->passlogic_tenant->get_tenant_data($tenant); if (is_null($data)) { return false; } else { return true; } } public function createTenant($tenant, $params_set) { global $passlogic_config; try { getPDO()->beginTransaction(); if (!$this->passlogic_tenant->put_tenantdata($tenant, $params_set)) { getPDO()->rollBack(); return false; } if (!$passlogic_config->put_config('domain', 'local', $tenant, array('domainname' => 'local'))) { getPDO()->rollBack(); return false; } $admin_policy = $passlogic_config->get_config('root_admin_policy', DEFAULT_POLICY, ''); if (!$passlogic_config->put_config('admin_policy', DEFAULT_POLICY, $tenant, $admin_policy)) { getPDO()->rollBack(); return false; } $policy = $passlogic_config->get_config('root_policy', DEFAULT_POLICY, ''); if (!$passlogic_config->put_config('policy', DEFAULT_POLICY, $tenant, $policy)) { getPDO()->rollBack(); return false; } $general_conf = $passlogic_config->get_config('root_general_config', 'default', ''); if (!$passlogic_config->put_config('general_config', 'default', $tenant, $general_conf)) { getPDO()->rollBack(); return false; } $mail_conf = $passlogic_config->get_config('root_mail_config', 'default', ''); if (!$passlogic_config->put_config('mail_config', 'default', $tenant, $mail_conf)) { getPDO()->rollBack(); return false; } $pki_conf = array(); $pki_conf['dummy'] = '1'; if (!$passlogic_config->put_config('PKI', 'default', $tenant, $pki_conf, $passlogic_config::AVAILABLE)) { getPDO()->rollBack(); return false; } getPDO()->commit(); put_tenant(); return true; } catch (Exception $e) { getPDO()->rollBack(); return false; } } public function deleteTenant($tenant) { global $passlogic_config; if (!$tenant) { return false; } try { getPDO()->beginTransaction(); $passlogic_user = new passLogic_user(getPDO()); if (!$passlogic_user->del_all_userdata($tenant)) { getPDO()->rollBack(); return false; } $passlogic_cert = new passLogic_cert(getPDO()); if (!$passlogic_cert->del_clientCA(array('tenant' => $tenant))) { getPDO()->rollBack(); return false; } $passlogic_token = new passLogic_token(getPDO()); if (!$passlogic_token->del_token(array('tenant' => $tenant))) { getPDO()->rollBack(); return false; } $passlogic_session = new passlogic_session(getPDO()); if (!$passlogic_session->del_session(array('tenant' => $tenant))) { getPDO()->rollBack(); return false; } $passlogic_admin = new passLogic_admin(getPDO()); if (!$passlogic_admin->del_all_userdata($tenant)) { getPDO()->rollBack(); return false; } if (!$passlogic_config->del_all_config($tenant)) { getPDO()->rollBack(); return false; } if (!$this->passlogic_tenant->delete_tenantdata($tenant)) { getPDO()->rollBack(); return false; } getPDO()->commit(); put_tenant(); require_once(LIB_DIR . "/cron_setting_util.php"); put_cron(false); return true; } catch (Exception $e) { getPDO()->rollBack(); return false; } } function getTenantMenuPermission($tenant) { global $passlogic_config; $menu_list = array( 'tenantList.php' => 'tenantList.php', 'tenantForm.php' => 'tenantForm.php', 'userList.php' => 'userList.php', 'userForm.php' => 'userForm.php', 'userimportForm.php' => 'userimportForm.php', 'domainList.php' => 'domainList.php', 'radiusList.php' => 'radiusList.php', 'uagentList.php' => 'uagentList.php', 'proxyList.php' => 'proxyList.php', 'ssoList.php' => 'ssoList.php', 'samlspList.php' => 'samlspList.php', 'samlCert.php' => 'samlCert.php', 'adminList.php' => 'adminList.php', 'adminForm.php' => 'adminForm.php', 'configAdminPolicyForm.php' => 'configAdminPolicyForm.php', 'configPasslogicForm.php' => 'configPasslogicForm.php', 'policyList.php' => 'policyList.php', 'groupList.php' => 'groupList.php', 'ip_groupList.php' => 'ip_groupList.php', 'tokenList.php' => 'tokenList.php', 'configUilangList.php' => 'configUilangList.php', 'configPKIForm.php' => 'configPKIForm.php', 'generateClientCAList.php' => 'generateClientCAList.php', 'clientCAList.php' => 'clientCAList.php', 'license.php' => 'license.php', 'backupForm.php' => 'backupForm.php', 'restore.php' => 'restore.php', 'supportForm.php' => 'supportForm.php', 'logList.php' => 'logList.php', 'passwd.php' => 'passwd.php' ); if (MULTI_TENANT) { if ($tenant) { unset($menu_list['tenantList.php']); unset($menu_list['tenantForm.php']); unset($menu_list['configUilangList.php']); unset($menu_list['radiusList.php']); if ($this->isTenantAdmin()) { $permission_data = $this->getTenantData($tenant)['permission']; $confList = $passlogic_config->get_config_list('', $tenant); $domain_disable_flag = !$permission_data['domain']; $uagent_disable_flag = !$permission_data['uagent']; $saml_disable_flag = !$permission_data['saml']; $group_disable_flag = !$permission_data['group']; $ip_group_disable_flag = !$permission_data['ip_group']; $token_disable_flag = !$permission_data['token']; $policy_disable_flag = !$permission_data['policy']; foreach ((array)$confList as $conf) { if ($conf['type'] == 'domain') { if ($conf['permission'] >= passlogic_config::READABLE) { $domain_disable_flag = false; } } else if ($conf['type'] == 'uagent') { if ($conf['permission'] >= passlogic_config::READABLE) { $uagent_disable_flag = false; } } else if ($conf['type'] == 'saml') { if ($conf['permission'] >= passlogic_config::READABLE) { $saml_disable_flag = false; } } else if ($conf['type'] == 'group') { if ($conf['permission'] >= passlogic_config::READABLE) { $group_disable_flag = false; } } else if ($conf['type'] == 'ip_group') { if ($conf['permission'] >= passlogic_config::READABLE) { $ip_group_disable_flag = false; } } else if ($conf['type'] == 'token') { if ($conf['permission'] >= passlogic_config::READABLE) { $token_disable_flag = false; } } else if ($conf['type'] == 'policy') { if ($conf['permission'] >= passlogic_config::READABLE) { $policy_disable_flag = false; } } } if ($domain_disable_flag) { unset($menu_list['domainList.php']); } if ($uagent_disable_flag) { unset($menu_list['uagentList.php']); } if ($saml_disable_flag) { unset($menu_list['samlspList.php']); } if ($group_disable_flag) { unset($menu_list['groupList.php']); } if ($ip_group_disable_flag) { unset($menu_list['ip_groupList.php']); } if ($token_disable_flag) { unset($menu_list['tokenList.php']); } if ($policy_disable_flag) { unset($menu_list['policyList.php']); } if (!$permission_data['samlcert']) { unset($menu_list['samlCert.php']); } if (!$permission_data['config']) { unset($menu_list['configPasslogicForm.php']); } $pki_permission = $passlogic_config->get_config_permission('PKI', 'default', $tenant); if (!$this->readable($pki_permission)) { unset($menu_list['configPKIForm.php']); } if (!$permission_data['client_cert']) { unset($menu_list['generateClientCAList.php']); unset($menu_list['clientCAList.php']); } } else { unset($menu_list['passwd.php']); } } } else { unset($menu_list['tenantList.php']); unset($menu_list['tenantForm.php']); } return $menu_list; } public function getTenantPermissionList() { $permissionList = array( passlogic_config::EDITABLE => LANG_PERMISSION_EDITABLE, passlogic_config::READABLE => LANG_PERMISSION_READABLE, passlogic_config::AVAILABLE => LANG_PERMISSION_AVAILABLE, ); return $permissionList; } public function editable($permission) { if ($this->isMasterTenant()) { return true; } if (!MULTI_TENANT) { return true; } switch ($permission) { case passlogic_config::EDITABLE: return true; default: return false; } } public function readable($permission) { if ($this->isMasterTenant()) { return true; } if (!MULTI_TENANT) { return true; } switch ($permission) { case passlogic_config::EDITABLE: case passlogic_config::READABLE: return true; default: return false; } } public function available($permission) { if ($this->isMasterTenant()) { return true; } if (!MULTI_TENANT) { return true; } switch ($permission) { case passlogic_config::EDITABLE: case passlogic_config::READABLE: case passlogic_config::AVAILABLE: return true; default: return false; } } public function getPermissionString($permission) { $permissionList = $this->getTenantPermissionList(); if (array_key_exists($permission, $permissionList)) { return $permissionList[$permission]; } return $permissionList[passlogic_config::AVAILABLE]; } public function getTenantCount($where_set = NULL, $where_param = NULL) { return $this->passlogic_tenant->get_tenant_count($where_set, $where_param); } public function check_permission($type, $tenant) { $tenant_config = $this->passlogic_tenant->get_tenant_data($tenant); if (isset($tenant_config['permission'][$type])) { return ($tenant_config['permission'][$type] === passlogic_tenant::AVAILABLE); } return false; } public function getTenantParam($tenant) { $tenant_config = $this->passlogic_tenant->get_tenant_data($tenant); return $tenant_config['tenant_param']; } } ?>